import 'package:carousel_slider/carousel_controller.dart';
import 'package:carousel_slider/carousel_slider.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';
import 'package:smooth_page_indicator/smooth_page_indicator.dart';
class Carousel extends StatefulWidget {
  final Carouselparams carouselparams;
  Carousel({this.carouselparams});

  @override
  _CarouselState createState() => _CarouselState();
}
class _CarouselState extends State<Carousel> {
  int _currentIndex = 0;
  int _itemCount = 0;
  CarouselController buttonCarouselController = CarouselController();
  List<String>imagesList =[];
  List<String> templist =[];


  @override
  void initState() {
    // TODO: implement initState
    /*imagesList =[];
    imagesList = widget.carouselparams.imageList.split(',');
    setState(() {
      _itemCount = imagesList.length;
    });*/
    super.initState();
  }
  @override
  Widget build(BuildContext context) {
    templist = [];
    if(widget.carouselparams.image1!='null'){
      setState(() {
        templist.add(widget.carouselparams.image1);
      });
    }
    if(widget.carouselparams.image2!='null'){
      setState(() {
        templist.add(widget.carouselparams.image2);
      });
    }
    if(widget.carouselparams.image3!='null'){
      setState(() {
        templist.add(widget.carouselparams.image3);
      });
    }
    if(widget.carouselparams.image4!='null'){
      setState(() {
        templist.add(widget.carouselparams.image4);
      });
    }
    if(widget.carouselparams.image5!='null'){
      setState(() {
        templist.add(widget.carouselparams.image5);
      });
    }
    if(widget.carouselparams.image6!='null'){
      setState(() {
        templist.add(widget.carouselparams.image6);
      });
    }
    setState(() {
      imagesList = templist;
      _itemCount = imagesList.length;
    });

    double _screenHeight = MediaQuery.of(context).size.height;
    double _screenWidth = MediaQuery.of(context).size.width;
    double carouselHeight =  widget.carouselparams.containerHeight!=0.0
        ? widget.carouselparams.containerHeight
        : kIsWeb
          ? _screenWidth<550
          ?_screenHeight*0.25
          :_screenHeight*0.35
        :_screenHeight*0.25;

    return imagesList.isNotEmpty
        ? Stack(
          fit: StackFit.passthrough,
          overflow: Overflow.clip,
          alignment: Alignment.topCenter,
          children: [
            Container(
              height: carouselHeight,
              width: double.maxFinite,
              child: CarouselSlider.builder(
                options: CarouselOptions(
                  autoPlay: true,
                  enlargeCenterPage: true,
                  autoPlayInterval: Duration(seconds:  3),
                  scrollDirection: Axis.horizontal,
                  viewportFraction: 1.0,
                  // aspectRatio: 16/9,
                  autoPlayAnimationDuration: Duration(seconds: 2),
                  onPageChanged: (index, reason) {
                    setState(
                          () {
                        _currentIndex = index;
                      },
                    );
                  },
                ),
                itemCount: _itemCount,
                itemBuilder: (BuildContext context, int itemIndex,
                    int pageViewIndex) =>
                    ClipRRect(
                        borderRadius: BorderRadius.all(
                          Radius.circular(widget.carouselparams.imageBorderRadius!=0.0 ? widget.carouselparams.imageBorderRadius:10.0),
                        ),
                        child: Card(
                          color: widget.carouselparams.cardBackground ?? Colors.white,
                          child: Stack(
                            children: <Widget>[
                              imagesList[itemIndex]==null
                                  ? Text("No Data Found")
                                  : Image.network(
                                imagesList[itemIndex]??"",
                                fit: widget.carouselparams.imageFit == 'Cover'
                                    ? BoxFit.cover
                                    : widget.carouselparams.imageFit == 'Fill'
                                    ? BoxFit.fill
                                    : widget.carouselparams.imageFit == 'FitWidth'
                                    ? BoxFit.fitWidth
                                    : widget.carouselparams.imageFit == 'FitHeight'
                                    ? BoxFit.fitHeight
                                    : widget.carouselparams.imageFit == 'Contain'
                                    ? BoxFit.contain
                                    : widget.carouselparams.imageFit == 'ScaleDown'
                                    ? BoxFit.scaleDown
                                    : widget.carouselparams.imageFit == 'None'
                                    ? BoxFit.none
                                    : BoxFit.cover,
                                width: double.maxFinite,
                                height: carouselHeight
                              )

                            ],
                          ),
                        )
                    ),
              ),
            ),
            Container(
              alignment: Alignment.bottomCenter,
              height: carouselHeight-10,
              width: double.maxFinite,
              child: Row(
                mainAxisAlignment: MainAxisAlignment.center,
                children: <Widget>[
                  AnimatedSmoothIndicator(
                    activeIndex:_currentIndex ,
                    count: _itemCount,
                    effect: JumpingDotEffect(
                        verticalOffset: 2,
                        dotHeight: 10,
                        dotWidth: 10,
                        activeDotColor: widget.carouselparams.dotColor,
                        dotColor: widget.carouselparams.dotColor.withOpacity(0.2)),
                  )

                ],
              ),
            )
          ],
        )
        : Container();
  }
}
