import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class CheckBoxParameters {
  Widget text;
  bool tristate;
  Color activeColor;
  Color checkColor;
  Color focusColor;
  Color hoverColor;

  CheckBoxParameters(
      {this.tristate,
      this.activeColor,
      this.hoverColor,
      this.checkColor,
      this.focusColor});
}

// ignore: must_be_immutable
class CustomCheckBox extends StatefulWidget {
  CheckBoxParameters param;
  CustomCheckBox(this.param);

  @override
  _MyStatefulWidgetState createState() => _MyStatefulWidgetState();
}

class _MyStatefulWidgetState extends State<CustomCheckBox> {
  bool val = false;
  @override
  Widget build(BuildContext context) {
    return Transform.scale(
      scale: 1.5,
      child: Checkbox(
        hoverColor: (widget.param.hoverColor != null) ? widget.param.hoverColor : Colors.black,
        focusColor: (widget.param.focusColor != null) ? widget.param.focusColor : Colors.black,
        tristate: (widget.param.tristate != null) ? widget.param.tristate : false,
        activeColor:
            (widget.param.activeColor != null) ? widget.param.activeColor : Colors.black,
        checkColor: (widget.param.checkColor != null) ? widget.param.checkColor : Colors.black,
        value: val,
        onChanged: (bool value) {
          print(value);
          setState(() {
            val = value;
          });
        },
      ),
    );
  }
}
