
import 'dart:collection';

import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class DTS extends DataTableSource {
  Map<dynamic, dynamic> map = new HashMap();
  bool showSerialNo;
  DTS({this.map, this.showSerialNo});

  @override
  DataRow getRow(int index) {
    final rowData = map.values.elementAt(index);

    List<DataCell> dataCellList = [];
    if (showSerialNo) dataCellList.add(DataCell(Text((index + 1).toString())));

    for (var key in rowData.keys) {
      if (key == "image") {
        dataCellList.add(new DataCell(Padding(
          padding: const EdgeInsets.only(left: 8.0),
          child: CircleAvatar(radius: 20, backgroundImage: NetworkImage(rowData[key][0])),
        )));
      } else {
        for (int i = 0; i < rowData[key].length; i++) {
          dataCellList.add(new DataCell(Text(rowData[key][i].toString())));
        }
      }
    }
    return new DataRow(selected: false, cells: dataCellList);
  }

  @override
  bool get isRowCountApproximate => false;

  @override
  int get rowCount => map.length;

  @override
  
  int get selectedRowCount => 0;
}
