import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
class ModifyEvent extends StatefulWidget {
  final String eventName;
  final String eventDesc;
  final DateTime startTime;
  final DateTime endTime;
  final Function(String,String,TimeOfDay,TimeOfDay,bool,String) event_val;
  final bool copm_val;
  ModifyEvent({@required this.eventDesc
    ,@required this.eventName
    ,@required this.startTime
    ,@required this.endTime
    ,@required this.event_val
    , @required this.copm_val});

  @override
  _ModifyEventState createState() => _ModifyEventState();
}

class _ModifyEventState extends State<ModifyEvent>   {
  TextEditingController eventController = new TextEditingController();
  TextEditingController decriptionController = new TextEditingController();
  bool completed = false;
  TimeOfDay time = TimeOfDay(hour: 0, minute: 0);
  TimeOfDay timeEnd = TimeOfDay(hour: 0, minute: 0);

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    eventController.text = widget.eventName;
    decriptionController.text = widget.eventDesc;
    time =  TimeOfDay(hour: widget.startTime.hour, minute: widget.startTime.minute);
    timeEnd = TimeOfDay(hour: widget.endTime.hour, minute: widget.endTime.minute);
    completed = widget.copm_val;
  }
  @override
  Widget build(BuildContext context) {
    return Container(
      child:  AlertDialog(
        clipBehavior: Clip.antiAlias,
        shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(10)),
        title: Row(
          mainAxisAlignment: MainAxisAlignment
              .spaceBetween,
          children: [
            Text('Modify Event'),
          ],
        ),
        content: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            TextField(
              controller: eventController,
              decoration: InputDecoration(
                  prefixIcon: Icon(Icons.event,size: 20,),
                  hintText: "Event-Name",
                  border: OutlineInputBorder(
                    borderRadius: BorderRadius.circular(5),
                  )
              ),
            ),
            SizedBox(height: 8,),
            TextField(
              controller: decriptionController,
              decoration: InputDecoration(
                  prefixIcon: Icon(Icons.description,size: 20,),
                  hintText: "Event-Description",
                  border: OutlineInputBorder(
                    borderRadius: BorderRadius.circular(5),
                  )
              ),
            ),
            SizedBox(height: 15,),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                ElevatedButton(
                  style: ButtonStyle(
                      backgroundColor: MaterialStateProperty.all(Colors.blueGrey),
                      shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                          RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(5),
                              side: BorderSide(color: Colors.blueGrey, width: 1.0)))),
                  child: Text(getText()),
                  onPressed: () {
                    pickTime(context);
                  },
                ),
                ElevatedButton(
                  style: ButtonStyle(
                      backgroundColor: MaterialStateProperty.all(Colors.blueGrey),
                      shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                          RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(5),
                              side: BorderSide(color: Colors.blueGrey, width: 1.0)))),
                  child: Text(getendText()),
                  onPressed: () {
                    pickendTime(context);
                    //Navigator.pop(context);
                  },
                ),
              ],
            ),
            SizedBox(height: 8,),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Row(
                  children: [
                    Text('Completed'),
                    Checkbox(value: completed, onChanged: (val){setState(() {
                      completed = val;
                      //print(val.toString());
                    });
                    })
                  ],
                ),
                ElevatedButton(
                  style: ButtonStyle(
                      backgroundColor: MaterialStateProperty.all(Colors.red),
                      shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                          RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(5),
                              side: BorderSide(color: Colors.red, width: 1.0)))),
                  child: Icon(Icons.delete, color: Colors.white,size: 20,),
                  onPressed: () {
                    widget.event_val(eventController.text,decriptionController.text,time,timeEnd,completed,'Delete');
                    Navigator.pop(context);
                  },
                ),
              ],
            )
          ],
        ),
        actions: [
          ElevatedButton(
            style: ButtonStyle(
                backgroundColor: MaterialStateProperty.all(Colors.green),
                shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                    RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(10),
                        side: BorderSide(color: Colors.green, width: 1.0)))),
            child: Text('Yes'),
            onPressed: () {
              widget.event_val(eventController.text,decriptionController.text,time,timeEnd,completed,'Yes');
              Navigator.pop(context);
            },
          ),
          ElevatedButton(
            style: ButtonStyle(
                backgroundColor: MaterialStateProperty.all(Colors.red),
                shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                    RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(10),
                        side: BorderSide(color: Colors.red, width: 1.0)))),
            child: Text('No'),
            onPressed: () {

              Navigator.pop(context);
            },
          ),
        ],
      ),
    );
  }
  Future pickTime(BuildContext context) async {
    final initialTime = TimeOfDay(hour: 9, minute: 0);
    final newTime = await showTimePicker(
      context: context,
      initialTime: time.hour==null ? initialTime:time,
    );

    if (newTime == null) return;
    setState(() {
      time = newTime;
      print(time.hour.toString());
    });
  }
  String getText(){
    if(time.hour==null){
      return widget.startTime.hour.toString()+":"+widget.startTime.minute.toString();
    }
    else{
      return '${time.hour}:${time.minute}';
    }
  }
  Future pickendTime(BuildContext context) async {
    final initialTime = TimeOfDay(hour: 9, minute: 0);
    final newTime = await showTimePicker(
      context: context,
      initialTime: timeEnd.hour==null ? initialTime:timeEnd,
    );

    if (newTime == null) return;
    setState(() {
      timeEnd = newTime;
      print(timeEnd.hour.toString());
    });
  }
  String getendText(){
    if(timeEnd.hour==null){
      return widget.endTime.hour.toString()+":"+widget.endTime.minute.toString();
    }
    else{
      return  '${timeEnd.hour}:${timeEnd.minute}';
    }
  }
}
